---
tomcat_version: 9.0.88
gs_tomcat_server_xml: |
  <?xml version="1.0" encoding="UTF-8"?>
  {{ gs_ansible_managed | comment('xml') }}
  <Server port="8007" shutdown="SHUTDOWN">
    <Listener className="org.apache.catalina.core.AprLifecycleListener" SSLEngine="True"  />
    <Listener className="org.apache.catalina.startup.VersionLoggerListener"  />
    <Listener className="org.apache.catalina.core.JreMemoryLeakPreventionListener"  />
    <Listener className="org.apache.catalina.mbeans.GlobalResourcesLifecycleListener"  />
    <Listener className="org.apache.catalina.core.ThreadLocalLeakPreventionListener"  />

    <GlobalNamingResources>
      <Resource name="UserDatabase" auth="Container"
                type="org.apache.catalina.UserDatabase"
                description="User database that can be updated and saved"
                factory="org.apache.catalina.users.MemoryUserDatabaseFactory"
                pathname="conf/tomcat-users.xml" />
    </GlobalNamingResources>

    <Service name="Catalina">
      <Connector port="8080" protocol="HTTP/1.1" connectionTimeout="20000" URIEncoding="UTF-8" redirectPort="{{ tomcat_ssl_connector_port }}"  />
      <Connector port="{{ tomcat_ssl_connector_port }}"
        URIEncoding="ISO-8859-1"
        protocol="HTTP/1.1"
        SSLEnabled="true"
        maxThreads="150"
        scheme="https"
        secure="True"
        clientAuth="False"
        sslProtocol="TLSv1.2"
        SSLCipherSuite="ECDHE-RSA-AES128-GCM-SHA256"
        keystoreFile="{{ tomcat_cacerts2_certificates[0]['deploy']['keystore']['dest'] }}"
        keystorePass="{{ tomcat_cacerts2_certificates[0]['deploy']['keystore']['password'] }}"
        keyAlias="{{ gs_certificate_alias }}"
        SSLHonorCipherOrder="true"
        server="server"  />
      <Connector port="8009" protocol="AJP/1.3" tomcatAuthentication="true" secretRequired="false" redirectPort="{{ tomcat_ssl_connector_port }}"  />
      <Engine name="Catalina" defaultHost="localhost"  >
        <Realm className="org.apache.catalina.realm.UserDatabaseRealm" resourceName="UserDatabase"  />
        <Host name="localhost" appBase="webapps" unpackWARS="true" autoDeploy="true" >
          <Valve className="org.apache.catalina.valves.RemoteIpValve"
            internalProxies="{{ gs_tomcat_internal_proxies | join('|') | replace('.', '\\.') }}"
            remoteIpHeader="X-Forwarded-For"
            protocolHeader="X-Forwarded-Proto"  />
          <Valve className="org.apache.catalina.valves.ErrorReportValve" showReport="false" showServerInfo="false"  />
          <Valve className="org.apache.catalina.valves.AccessLogValve" directory="logs" prefix="localhost" suffix=".log" pattern="%h %l %u %t &quot;%r&quot; %s %b"  />
          "{{ gs_tomcat_contexts | default([]) }}"
        </Host>
      </Engine>
    </Service>
  </Server>
